##  --------------------------------------------------------------------------------
##  $Id: LV.pm,v 1.1 2002/12/27 16:03:58 joko Exp $
##  --------------------------------------------------------------------------------
##  $Log: LV.pm,v $
##  Revision 1.1  2002/12/27 16:03:58  joko
##  + initial check-in
##
##  --------------------------------------------------------------------------------


package Data::Query::Element::LV;

use strict;
use warnings;

use base 'DesignPattern::Object';
use base 'DesignPattern::Object::Logger';


use Data::Dumper;

sub _init {
  my $self = shift;
  # get single argument already stuffed from designpattern-base-object (hopefully)
  $self->{value} = $self->{__arg};
  delete $self->{__arg};
}

sub __check {
  my $self = shift;
  if (!defined $self->{value}) {
    return;
  }
  return 1;
}

sub eq {
  my $self = shift;
  my $val = shift;
  return if !$self->__check();
  return 1 if $self->{value} eq $val;
}

sub value {
  my $self = shift;
  return $self->{value};
}

sub toString {
  my $self = shift;
  my $val = $self->value();
  $val ||= '';
  return $val;
}

sub undefined {
  my $self = shift;
  my $val = $self->value();
  return !($val);
}

sub set {
  my $self = shift;
  return $self->{value} = shift;
}

1;
