##    --------------------------------------------------------------------------------
##    $Id: Directory.pm,v 1.1 2003/01/19 02:11:37 joko Exp $
##    --------------------------------------------------------------------------------
##    $Log: Directory.pm,v $
##    Revision 1.1  2003/01/19 02:11:37  joko
##    + from libp
##
##    --------------------------------------------------------------------------------


package Data::Storage::Handler::Directory;

use strict;
use warnings;

use base ("Data::Storage::Handler::Abstract");

require Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw( 
  getDirList
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -   main

use DirHandle;

use Data::Dumper;
#use Data::Storage::Result::Files;

# get logger instance
my $logger = Log::Dispatch::Config->instance;

sub getMetaInfo {
  my $self = shift;
  $logger->debug( __PACKAGE__ . "->getMetaInfo()"  );
  return;
  return {
#    'disconnectMethod' => 'disconnect',
  };
}



# =============================================
# "global" vars used in directory-recursive-parsing
my $dirlist_buf;
my @dirlist_path;
my $dirlist_base;


sub entry_callback {

  my $entry = shift;

  # CHECKS
  # dont't use this:
  if ($entry eq '.' || $entry eq '..') { return; }

  # PREPARE
  # prepare path to current entry
  my $cur_entry = join('/', @dirlist_path, $entry);
  # prepare path to current entry (absolute)
  my $cur_entry_abs = join('/', $dirlist_base, @dirlist_path, $entry);

  # ENTRY
  # add current entry to buffer
  $dirlist_buf .= $cur_entry . "\n";

  # (SUB-)DIRECTORY
  # check if current entry is a (sub-)directory ...
  if (-d $cur_entry_abs) {
    push @dirlist_path, $cur_entry;
    # ... and parse this (recursion here!!!)
    iterate_path($cur_entry_abs);
    pop @dirlist_path;
  }
}

sub iterate_path {

  my $path = shift;

  # create new "DirHandle"-object
  my $d = new DirHandle $path;
  if (defined $d) {

    # iterate through all entries in $path ($d->read) and call out entry-handler on each entry
    while (defined(my $line = $d->read)) { 
      entry_callback($line); 
    }

    undef $d;
  }
}

sub getDirList {

  $dirlist_base = shift;

  # reset vars
  $dirlist_buf = '';
  @dirlist_path = ();

  # start parsing file-structure
  iterate_path($dirlist_base);

  # return complete list of directory-content including files and subdirs
  # entries are newline (\n) - seperated
  return $dirlist_buf;

}

1;
