############################################
#
#  $Id: Tangram.pm,v 1.2 2002/12/05 08:01:26 joko Exp $
#
#  $Log: Tangram.pm,v $
#  Revision 1.2  2002/12/05 08:01:26  joko
#  + sub getStatus utilizing isEmpty to determine if result is set/unset and/or filled/unfilled
#
#  Revision 1.1  2002/11/29 04:55:45  joko
#  + initial check-in
#
#
############################################


package Data::Storage::Result::Tangram;

use strict;
use warnings;

use base ("Data::Storage::Result::Abstract");
use Data::Dumper;
use Data::Compare::Struct qw( isEmpty );

sub DESTROY {
  my $self = shift;
  #$logger->debug( __PACKAGE__ . "->" . "DESTROY" );
  $self->{RESULTHANDLE} && $self->{RESULTHANDLE}->close();
}

sub getNextEntry {
  my $self = shift;
  
  return if !$self->{RESULTHANDLE};
  $self->{resulthandle_type} = ref($self->{RESULTHANDLE}) if !$self->{resulthandle_type};
  
  # is result already opened?
  if ($self->{open}) {
    $self->{entry_count}++;
    return $self->{RESULTHANDLE}->next()
      if $self->{resulthandle_type} eq 'Tangram::Cursor';
    return $self->{members}->[$self->{entry_count}]
      if $self->{resulthandle_type} eq 'Set::Object';

  # open result!
  } else {
    $self->{entry_count} = 0;
    return $self->{RESULTHANDLE}->execute()
      if $self->{resulthandle_type} eq 'Tangram::Cursor';
    #print Dumper($self->{RESULTHANDLE}->members()); exit;
    if ($self->{resulthandle_type} eq 'Set::Object') {
      my @members = $self->{RESULTHANDLE}->members();
      $self->{members} = \@members;
      return $self->{members}->[$self->{entry_count}];
    }
    $self->{open} = 1;
  }
}

sub getStatus {
  my $self = shift;
  my $status;
  if ($self->{resulthandle_type} eq 'Tangram::Cursor') {
    $status = {
      err => $self->{RESULTHANDLE}->err,
      errstr => $self->{RESULTHANDLE}->errstr,
      state => $self->{RESULTHANDLE}->state,
    };
  }
  if ($self->{resulthandle_type} eq 'Set::Object') {
    #print Dumper($self->{RESULTHANDLE}->members());
    $status = {
      empty => isEmpty($self->{RESULTHANDLE}),
    },
  }
  return $status;
}


1;
