##############################################
#
#  $Id: Encode.pm,v 1.2 2002/12/05 13:57:22 joko Exp $
#
#  $Log: Encode.pm,v $
#  Revision 1.2  2002/12/05 13:57:22  joko
#  + now able to export 'scalar2utf8'
#  + comments
#
#  Revision 1.1  2002/11/29 04:49:20  joko
#  + initial check-in
#
#  Revision 1.1  2002/10/10 03:26:00  cvsjoko
#  + new
#
##############################################


package Data::Transform::Encode;

use strict;
use warnings;

require Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw( &var2utf8 &var_utf2iso &scalar2utf8 );

use Unicode::String qw(utf8 latin1);

# TODO: refactor using Greg London's "Iterate" from CPAN
sub var2utf8 {
  my $vref = shift;
  if (ref $vref eq 'HASH') {
    foreach (keys %{$vref}) {
      if ((ref $vref->{$_}) =~ m/ARRAY|HASH/) {
        var2utf8($vref->{$_});
      } else {
        $vref->{$_} = scalar2utf8($vref->{$_});
      }
    }
  } elsif (ref $vref eq 'ARRAY') {
    foreach (@{$vref}) {
      if (ref $_ ne 'SCALAR') {
        var2utf8($_);
      } else {
        $_ = scalar2utf8($_);
      }
    }
  }
  
}

sub scalar2utf8 {
  my $scalar = shift;
  if ($scalar) {
    my $u = latin1($scalar);
    return $u->utf8;
  }
}

# TODO: refactor using Greg London's "Iterate" from CPAN
sub var_utf2iso {
  my $vref = shift;
  if (ref $vref eq 'HASH') {
    foreach (keys %{$vref}) {
      if ((ref $vref->{$_}) =~ m/ARRAY|HASH/) {
        var_utf2iso($vref->{$_});
      } else {
        $vref->{$_} = scalar2iso($vref->{$_});
      }
    }
  } elsif (ref $vref eq 'ARRAY') {
    foreach (@{$vref}) {
      if (ref $_ ne 'SCALAR') {
        var_utf2iso($_);
      } else {
        $_ = scalar2iso($_);
      }
    }
  }
  
}

sub scalar2iso {
  my $scalar = shift;
  if ($scalar) {
    my $u = utf8($scalar);
    return $u->latin1;
  }
}

1;
