##    --------------------------------------------------------------------------------
##    $Id: PurePerl.pm,v 1.1 2002/12/19 16:36:29 joko Exp $
##    --------------------------------------------------------------------------------
##    $Log: PurePerl.pm,v $
##    Revision 1.1  2002/12/19 16:36:29  joko
##    + added as an alternative to Data::UUID which is written in c language (XS-code) and somehow fails to compile with ActiveState/VC
##    + this module utilizes Digest::MD5 which should work without problems on ActiveState, too
##
##    --------------------------------------------------------------------------------



# derived from:
# CGI::Session::ID::MD5 - default CGI::Session ID driver
# Id: MD5.pm,v 3.2 2002/11/27 12:30:26 sherzodr Exp
# please visit http://search.cpan.org/src/SHERZODR/CGI-Session-3.11/Session/ID/MD5.pm

package Data::UUID::PurePerl;

# $Id: PurePerl.pm,v 1.1 2002/12/19 16:36:29 joko Exp $

use strict;
use Digest::MD5;
use vars qw($VERSION);

($VERSION) = '$Revision: 1.1 $' =~ m/Revision:\s*(\S+)/;

sub generate_id {
    #my $self = shift;

    my $md5 = new Digest::MD5();
    $md5->add($$ , time() , rand(9999) );

    return $md5->hexdigest();
}

sub generate_id_blocks {
  my $count = shift;
  my @id;
  for (1..$count) {
    push @id, generate_id();
  }
  my $id = join('-', @id);
  return $id;
}

1;
